ompi/mca/ptl/base/ptl_base_match.c File Reference.TH "ompi/mca/ptl/base/ptl_base_match.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/base/ptl_base_match.c \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <stdio.h>\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'communicator/communicator.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/ptl/ptl.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_comm.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_recvfrag.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_header.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_match.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_BASE_CHECK_WILD_RECEIVES_FOR_MATCH\fP(frag_header, pml_comm, return_match)"
.br
.RI "\fITry and match the incoming message fragment to the list of 'wild' receives. \fP"
.ti -1c
.RI "#define \fBMCA_PTL_BASE_CHECK_SPECIFIC_RECEIVES_FOR_MATCH\fP(frag_header, pml_comm, return_match)"
.br
.RI "\fITry and match the incoming message fragment to the list of 'specific' receives. \fP"
.ti -1c
.RI "#define \fBMCA_PTL_BASE_CHECK_SPECIFIC_AND_WILD_RECEIVES_FOR_MATCH\fP(frag_header, pml_comm, return_match)"
.br
.RI "\fITry and match the incoming message fragment to the list of 'wild' receives and 'specific' receives. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "static bool \fBmca_ptl_base_check_cantmatch_for_match\fP (\fBopal_list_t\fP *additional_matches, \fBmca_pml_ptl_comm_t\fP *pml_comm, int frag_src)"
.br
.RI "\fIScan the list of frags that came in ahead of time to see if any can be processed at this time. \fP"
.ti -1c
.RI "bool \fBmca_ptl_base_match\fP (\fBmca_ptl_base_match_header_t\fP *frag_header, \fBmca_ptl_base_recv_frag_t\fP *frag_desc, \fBopal_list_t\fP *additional_matches, bool *additional_match)"
.br
.RI "\fIRCS/CTS receive side matching. \fP"
.ti -1c
.RI "bool \fBmca_ptl_base_match_in_order_network_delivery\fP (\fBmca_ptl_base_match_header_t\fP *frag_header, struct \fBmca_ptl_base_recv_frag_t\fP *frag_desc)"
.br
.RI "\fIRCS/CTS receive side matching. \fP"
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_PTL_BASE_CHECK_SPECIFIC_AND_WILD_RECEIVES_FOR_MATCH(frag_header, pml_comm, return_match)"
.PP
Try and match the incoming message fragment to the list of 'wild' receives and 'specific' receives. 
.PP
Used when both types of receives have been posted, i.e. when we need to coordinate between multiple lists to make sure ordered delivery occurs.
.PP
\fBParameters:\fP
.RS 4
\fIfrag_header\fP Matching data from recived fragment (IN)
.br
\fIpml_comm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Matched receive
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SS "#define MCA_PTL_BASE_CHECK_SPECIFIC_RECEIVES_FOR_MATCH(frag_header, pml_comm, return_match)"
.PP
Try and match the incoming message fragment to the list of 'specific' receives. 
.PP
\fBParameters:\fP
.RS 4
\fIfrag_header\fP Matching data from recived fragment (IN)
.br
\fIpml_comm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Matched receive
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SS "#define MCA_PTL_BASE_CHECK_WILD_RECEIVES_FOR_MATCH(frag_header, pml_comm, return_match)"
.PP
Try and match the incoming message fragment to the list of 'wild' receives. 
.PP
\fBParameters:\fP
.RS 4
\fIfrag_header\fP Matching data from recived fragment (IN)
.br
\fIpml_comm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Matched receive
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SH "Function Documentation"
.PP 
.SS "static bool mca_ptl_base_check_cantmatch_for_match (\fBopal_list_t\fP * additional_matches, \fBmca_pml_ptl_comm_t\fP * pml_comm, int frag_src)\fC [static]\fP"
.PP
Scan the list of frags that came in ahead of time to see if any can be processed at this time. 
.PP
If they can, try and match the frags.
.PP
\fBParameters:\fP
.RS 4
\fIadditional_matches\fP List to hold new matches with fragments from the c_frags_cant_match list. (IN/OUT)
.br
\fIpml_comm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SS "bool mca_ptl_base_match (\fBmca_ptl_base_match_header_t\fP * frag_header, \fBmca_ptl_base_recv_frag_t\fP * frag_desc, \fBopal_list_t\fP * additional_matches, bool * additional_match)"
.PP
RCS/CTS receive side matching. 
.PP
\fBParameters:\fP
.RS 4
\fIfrag_header\fP list of parameters needed for matching This list is also embeded in frag_desc, but this allows to save a memory copy when a match is made in this routine. (IN) 
.br
\fIfrag_desc\fP pointer to receive fragment which we want to match (IN/OUT). If a match is not made, frag_header is copied to frag_desc. 
.br
\fImatch_made\fP parameter indicating if we matched frag_desc/ frag_header (OUT) 
.br
\fIadditional_matches\fP if a match is made with frag_desc, we may be able to match fragments that previously have arrived out-of-order. If this is the case, the associated fragment descriptors are put on this list for further processing. (OUT)
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
This routine is used to try and match a newly arrived message fragment to pre-posted receives. The following assumptions are made
.IP "\(bu" 2
fragments are received out of order
.IP "\(bu" 2
for long messages, e.g. more than one fragment, a RTS/CTS algorithm is used.
.IP "\(bu" 2
2nd and greater fragments include a receive descriptor pointer
.IP "\(bu" 2
fragments may be dropped
.IP "\(bu" 2
fragments may be corrupt
.IP "\(bu" 2
this routine may be called simultaneously by more than one thread 
.PP

.SS "bool mca_ptl_base_match_in_order_network_delivery (\fBmca_ptl_base_match_header_t\fP * frag_header, struct \fBmca_ptl_base_recv_frag_t\fP * frag_desc)"
.PP
RCS/CTS receive side matching. 
.PP
\fBParameters:\fP
.RS 4
\fIfrag_header\fP list of parameters needed for matching This list is also embeded in frag_desc, but this allows to save a memory copy when a match is made in this routine. (IN) 
.br
\fIfrag_desc\fP pointer to receive fragment which we want to match (IN/OUT). If a match is not made, frag_header is copied to frag_desc. 
.br
\fImatch_made\fP parameter indicating if we matched frag_desc/ frag_header (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
indication if match was made or not.
.RE
.PP
This routine is used to try and match a newly arrived message fragment to pre-posted receives. The following assumptions are made
.IP "\(bu" 2
fragments are received in order, so no explicit sequence tracking is needed.
.IP "\(bu" 2
for long messages, e.g. more than one fragment, a RTS/CTS algorithm is used.
.IP "\(bu" 2
2nd and greater fragments include a receive descriptor pointer
.IP "\(bu" 2
this routine may be called simoultaneously by more than one thread
.PP
.PP
On return, if match is made: neither the fragment, nor the matched receive descriptor are on any list if match is not made: The fragment is placed on the unexpected fragment list 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
